// ============================================================================
//
// OctaveSupport.cpp
// Octave plots auto-generated for the N_Body_Simulator project
// CBP 29-03-22
//
// ============================================================================

#include <stdio.h>
#include "nbody.h"

void writeOctaveHead(FILE* file) {
	//fprintf(file, "xline = @(xval, varargin) line(xlim, [xval xval], varargin{:}); \n");
	fprintf(file, "clear all\n");
	fprintf(file, "A = [\n");

}


void writeDataToOctave(FILE* file, double time, Body *bodies, int n) {
	double x, y;

	fprintf(file, "%e ", time);
	for (int i = 0; i < n; i++) {
		x = bodies[i].pos[X];
		fprintf(file, "%e ", x);
	}
	for (int i = 0; i < n; i++) {
		y = bodies[i].pos[Y];
		fprintf(file, "%e ", y);
	}
	fprintf(file, "\n");

}

void writeOctaveTail(FILE* file, int n) {
	fprintf(file, "];\n");
	fprintf(file, "t  = A(:,1);\n");

	for (int i = 0; i < n; i++) {
		fprintf(file, "x%d = A(:,%d);\n", i, i + 2);
	}

	for (int i = 0; i < n; i++) {
		fprintf(file, "y%d = A(:,%d);\n", i, i + 2 + n);
	}

	fprintf(file, "plot(");

	for (int i = 0; i < n - 1; i++) {
		fprintf(file, "x%d,y%d,", i, i);
	}
	fprintf(file, "x%d,y%d)\n", n - 1, n - 1);

	//fprintf(file, "axis([%f,%f,%f,%f])\n", -maxR, maxR, -maxR, maxR);


}
