// ============================================================================
//
// CBP 02-04-22
//
// ============================================================================

#ifndef _NBODY_H
#define _NBODY_H

#include <stdlib.h>	
#include <stdio.h>	
#include <time.h>	
#include <malloc.h>	
#include <math.h>	
#include <omp.h>

#define GRAV_CONST 1.0	
#define EPSILON 1e-12
#define M_PI (4.0*atan(1.0))

#define X 0
#define Y 1

struct Body_struct {
    double mass;
    double pos[2];
    double vel[2];
};
typedef struct Body_struct Body;

Body* init_bodies(unsigned int num_bodies, int num_asteroids);
int check_simulation(Body* bodies, int num_bodies);
double elapsed_time(const clock_t t2, const clock_t t1);

#endif 


