// ============================================================================
//
// SourcePI.c
// Pi approximations
// CBP 01-04-22
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <math.h>
#include <omp.h>

#define NR_ITERATIONS 1000

int nrRequThreads;
int nrStrips;
clock_t t0, t1, t2;
double time2;
int nrProcs;
double* stripLengths;
double* x;

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------FFarmer-PI problem ---------------------\n");

	printf("\nRequest to system for cores and threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n\n", nrProcs);
	printf("Input number of threads you want  ");
	scanf_s("%d", &nrRequThreads);
	printf("Input number of strips you want  ");
	scanf_s("%d", &nrStrips);
	printf("\n");

	printf("\nCalculation running with %d iterations, %d threads and %d strips\n\n", NR_ITERATIONS, nrRequThreads, nrStrips);

	omp_set_dynamic(0);
	omp_set_num_threads(nrRequThreads);
	int threadNr;
	int i;
	int n = 10;
	double area = 0;
	double h;
	int repeat;

	stripLengths = (double*)malloc(nrStrips * sizeof(double));
	x = (double*)malloc(nrStrips * sizeof(double));

	// Start the timer here ------------------------------------------------
	t0 = clock();
	h = 1.0 / nrStrips;
	printf("h = %e\n", h);

	repeat = 0;
	while (repeat < NR_ITERATIONS) {
		// Code goes here









		repeat++;
	}

	// End the timer here ---------------------------------------------------
	t2 = clock();
	time2 = (double)(t2)-(double)(t0);
	printf("Time for the run = %e millisec (%f millisec)\n", time2, time2);

	double pi = area/repeat;
	double percentError = 100*(pi - 4 * atan(1)) / (4 * atan(1));

	printf("Approximate pi = %1.20e, Exact pi = %1.20e Percent error = %e\n", pi,4*atan(1.0), percentError);

}